Type t_Func As Function(iVal As Integer) As Integer

Dim Shared As t_Func pFunc  
Dim Shared As Any Ptr pThread
Dim Shared As Integer iSleep, iRunning


Sub CallFunc(pParam As Any Ptr)
	Dim As Integer iCnt = 0, iRet
	
	While iRunning = 1
		iCnt += 1
		iRet = pFunc(iCnt)
		If iRet = 1 Then
			Print "> Ret: "; iRet
		Else
			Print "! Ret: "; iRet
		EndIf
		Sleep(iSleep)
	Wend
End Sub


Extern "Windows-MS"

Function CallBackStart(pCBFunc As t_Func, iMS As Integer) As Integer Export
	pFunc = pCBFunc
	iSleep = iMS
	iRunning = 1
	pThread = ThreadCreate(@CallFunc, 0)
	Print "! CallBack Thread gestartet..."
	Return 1
End Function

Function CallBackStop As Integer Export
	iRunning = 0
	Print "! CallBack Thread wird beendet..."
	ThreadWait(pThread)
	Print "! CallBack Thread fertig"
	Return 1
End Function

End Extern